#include "Colony.h"

// RXgN^
// fileName: f[^Zbg̃t@C
Colony::Colony(char *fileName)
{
   int i;

   field = new Field(fileName);
   ant = new Ant* [ANT_NUM];
   for(i = 0; i < ANT_NUM; i++) {
     ant[i] = new Ant(this);
   }
   nume = new double* [field->nodeNum];
   for(i = 0; i < field->nodeNum; i++) {
      nume[i] = new double [field->nodeNum];
   }
}

// fXgN^
Colony::~Colony()
{
   int i;

   for(i = 0; i < ANT_NUM; i++) {
      delete ant[i];
   }
   delete [] ant;
   for(i = 0; i < field->nodeNum; i++) {
      delete [] nume[i];
   }
   delete [] nume;
   delete field;
}

// oHI
void Colony::selectRoute()
{
   int i, j;
   
   // m̕qZo
   for(i = 0; i < field->nodeNum; i++) {
      for(j = 1; j < i; j++) {
         nume[i][j] = pow(field->pheromone[j][i], PHERO_L)
                      * pow(1 / field->distance[i][j], HEU_L);
      }
      for(j = i + 1; j < field->nodeNum; j++) {
         nume[i][j] = pow(field->pheromone[i][j], PHERO_L)
                      * pow(1 / field->distance[i][j], HEU_L);
      }
   }

   // oHI
   for(i = 0; i < ANT_NUM; i++) {
      ant[i]->selectRoute();
   }
}

// tFʂXV
void Colony::renewPheromone()
{
   int i, j;

   // 
   for(i = 0; i < field->nodeNum; i++) {
      for(j = i + 1; j < field->nodeNum; j++) {
         field->pheromone[i][j] *= 1 - EVA_R;
      }
   }

   // AɂǉZ
   for(i = 0; i < ANT_NUM; i++) {
      ant[i]->putPheromone();
   }
}

// tFʂ\
void Colony::printPheromone()
{
   int i, j;

   for(i = 0; i < field->nodeNum; i++) {
      for(j = 0; j < field->nodeNum; j++) {
         printf("%8.3f", field->pheromone[i][j]);
      }
      printf("\n");
   }
}
