#include "Flower.h"

// RXgN^
// argFSet: ĂHƌW
Flower::Flower(FlowerSet *argFSet)
{
   int i;

   fSet = argFSet;
   pos = new double [fSet->dataset->exVarNum];
   for(i = 0; i < fSet->dataset->exVarNum; i++) {
      pos[i] = COEF_MIN + (COEF_MAX - COEF_MIN) * RAND_01;
   }
   visitNum = 0;
   evaluate();
}

// fXgN^
Flower::~Flower()
{
   delete [] pos;
}

// base̋߂̐HƌɕύX
// base: ƂɂHƌ̓Y
void Flower::change(int base)
{
   int i, j;

   for(i = 0; i < fSet->dataset->exVarNum; i++) {
      pos[i] = fSet->flower[base]->pos[i];
   }
   i = rand() % fSet->dataset->exVarNum;
   j = (base + (rand() % (EBEE_NUM - 1) + 1)) % EBEE_NUM;
   pos[i] = pos[i]
            + (rand() / (RAND_MAX / 2.0) - 1)
              * (pos[i] - fSet->flower[j]->pos[i]);
   visitNum = 0;
   evaluate();
}

// VHƌɕύX
void Flower::renew()
{
   int i;

   for(i = 0; i < fSet->dataset->exVarNum; i++) {
      pos[i] = COEF_MIN + (COEF_MAX - COEF_MIN) * RAND_01;
   }
   visitNum = 0;
   evaluate();
}

// ]lZo
void Flower::evaluate()
{
   int i, j;
   double diff;

   value = 0.0;
   for(i = 0; i < fSet->dataset->dataNum; i++) {
      diff = fSet->dataset->resSData[i];
      for(j = 0; j < fSet->dataset->exVarNum; j++) {
         diff -= pos[j] * fSet->dataset->exSData[i][j];
      }
      value += pow(diff, 2.0);
   }
}
