#include "Particle.h"

// RXgN^
// argSwarm: Ă闱qQ
Particle::Particle(Swarm *argSwarm)
{
   int i;

   swarm = argSwarm;
   pos = new double [swarm->dataset->exVarNum];
   velocity = new double [swarm->dataset->exVarNum];
   for(i = 0; i < swarm->dataset->exVarNum; i++) {
      pos[i] = COEF_MIN + (COEF_MAX - COEF_MIN) * RAND_01;
      velocity[i] = COEF_MIN + (COEF_MAX - COEF_MIN) * RAND_01;
   }
   pBestPos = new double [swarm->dataset->exVarNum];
   pBestValue = DBL_MAX;
   evaluate();
}

// fXgN^
Particle::~Particle()
{
   delete [] pos;
   delete [] velocity;
   delete [] pBestPos;
}

// qړ
void Particle::move()
{
   int i;

   for(i = 0; i < swarm->dataset->exVarNum; i++) {
      velocity[i] = INERTIA * velocity[i] 
                  + ACCEL_G * (swarm->gBestPos[i] - pos[i]) * RAND_01
                  + ACCEL_P * (pBestPos[i] - pos[i]) * RAND_01;
      pos[i] += velocity[i];
   }
   evaluate();
}

// ]lZoCp[\ixXgXV
void Particle::evaluate()
{
   int i, j;
   double diff;

   // ]lZo
   value = 0.0;
   for(i = 0; i < swarm->dataset->dataNum; i++) {
      diff = swarm->dataset->resSData[i];
      for(j = 0; j < swarm->dataset->exVarNum; j++) {
         diff -= pos[j] * swarm->dataset->exSData[i][j];
      }
      value += pow(diff, 2.0);
   }

   // p[\ixXgXV
   if(pBestValue > value) {
      for(i = 0; i < swarm->dataset->exVarNum; i++) {
         pBestPos[i] = pos[i];
      }
      pBestValue = value;
   }
}
