#include "Swarm.h"

// RXgN^
// fileName: f[^Zbg̃t@C
Swarm::Swarm(char *fileName)
{
   int i, best;

   dataset = new Dataset(fileName);
   particle = new Particle* [SWARM_SIZE];
   best = 0;
   for(i = 0; i < SWARM_SIZE; i++) {
      particle[i] = new Particle(this);
      if(particle[best]->value > particle[i]->value) {
         best = i;
      }
   }
   gBestPos = new double [dataset->exVarNum];
   for(i = 0; i < dataset->exVarNum; i++) {
      gBestPos[i] = particle[best]->pos[i];
   }
   gBestValue = particle[best]->value;
}

// fXgN^
Swarm::~Swarm()
{
   int i;

   for(i = 0; i < SWARM_SIZE; i++) {
      delete particle[i];
   }
   delete [] particle;
   delete [] gBestPos;
   delete dataset;
}

// qړCO[oxXgXV
void Swarm::move()
{
   int i, best;

   // ׂĂ̗qړ
   best = -1;
   for(i = 0; i < SWARM_SIZE; i++) {
      particle[i]->move();
      if(gBestValue > particle[i]->value) {
         best = i;
      }
   }

   // O[oxXgXV
   if(best != -1) {
      for(i = 0; i < dataset->exVarNum; i++) {
         gBestPos[i] = particle[best]->pos[i];
      }
      gBestValue = particle[best]->value;
   }   
}

// ʂ\
void Swarm::printResult()
{
   dataset->setCoef(gBestPos);
   dataset->printEquation();
}
