#include "Firefly.h"

// RXgN^
// argPop: Ăz^Q
Firefly::Firefly(Population *argPop)
{
   int i;

   pop = argPop;
   pos = new double [pop->dataset->exVarNum];
   for(i = 0; i < pop->dataset->exVarNum; i++) {
      pos[i] = COEF_MIN + (COEF_MAX - COEF_MIN) * RAND_01;
   }
   evaluate();
}

// fXgN^
Firefly::~Firefly()
{
   delete [] pos;
}

// basêق邩base̕Ɉړ
// base: rΏۂ̃z^
void Firefly::move(Firefly *base)
{
   int i;
   double dis;

   if(intensity > base->intensity) {
      // Zo
      dis = 0.0;
      for(i = 0; i < pop->dataset->exVarNum; i++) {
         dis += pow(base->pos[i] - pos[i], 2);
      }
      dis = sqrt(dis);

      // ړ肷
      for(i = 0; i < pop->dataset->exVarNum; i++) {
         pos[i] = pos[i]
                  + ATTRACT * exp(-ABSORB * dis) * (base->pos[i] - pos[i]) 
                  + RANDOMIZE * (RAND_01 - 0.5);
      }
      evaluate();
   }
}

// ̋xZo
void Firefly::evaluate()
{
   int i, j;
   double diff;

   intensity = 0.0;
   for(i = 0; i < pop->dataset->dataNum; i++) {
      diff = pop->dataset->resSData[i];
      for(j = 0; j < pop->dataset->exVarNum; j++) {
         diff -= pos[j] * pop->dataset->exSData[i][j];
      }
      intensity += pow(diff, 2.0);
   }
}
